aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ramips/mt7621
diff options
context:
space:
mode:
authorINAGAKI Hiroshi <musashino.open@gmail.com>2019-04-09 14:48:31 +0900
committerAdrian Schmutzler <freifunk@adrianschmutzler.de>2020-02-05 17:03:27 +0100
commit3c0e2aa63ef040dbfbd7fe5f05bc9dfaf5ae9242 (patch)
tree3462ba56042d1e1a28f75e5a04dc4d34c5d88511 /target/linux/ramips/mt7621
parentbe4d53bf69b63f0534fba37fad56dcf4c6de3e5c (diff)
downloadupstream-3c0e2aa63ef040dbfbd7fe5f05bc9dfaf5ae9242.tar.gz
upstream-3c0e2aa63ef040dbfbd7fe5f05bc9dfaf5ae9242.tar.bz2
upstream-3c0e2aa63ef040dbfbd7fe5f05bc9dfaf5ae9242.zip
ramips: add support for I-O DATA WN-DX1167R
I-O DATA WN-DX1167R is a 2.4/5 GHz band 11ac rotuer, based on MediaTek MT7621A. Specification: - SoC : MediaTek MT7621A - RAM : DDR3 128 MiB - Flash : NAND 128 MiB - WLAN : MediaTek MT7615D (2.4/5 GHz, 2T2R) - Ethernet : 5x 10/100/1000 Mbps - Switch : MediaTek MT7621A (MT7530) - LEDs/Input : 2x/3x (2x buttons, 1x slide-switch) - UART : through-hole on PCB - J5: Vcc, TX, RX, NC, GND - 57600 bps Flash instruction using initramfs image: 1. Boot WN-DX1167R normally 2. Access to "http://192.168.0.1/" and open firmware update page ("ファームウェア") 3. Select the OpenWrt initramfs image and click update ("更新") button to perform firmware update 4. On the initramfs image, perform sysupgrade with squashfs-sysupgrade image 5. Wait ~120 seconds to complete flashing Notes: - configuration in DeviceTree of DBDC (Dual-Band-Dual-Concurrent) mode for MT7615D chip is not supported in mt76 driver - last 0x80000 (512 KiB) in NAND flash is not used on stock firmware - stock firmware requires "customized uImage header" by MSTC (MitraStar Technology Corp.), but U-Boot doesn't - uImage magic (0x0 - 0x3) : 0x434F4D43 (COMC) - header crc32 (0x4 - 0x7) : with data length and data crc32 - image name (0x20 - 0x37) : model ID and firmware versions - data length (0x38 - 0x3b): kernel + rootfs - data crc32 (0x3c - 0x3f) : kernel + rootfs Signed-off-by: INAGAKI Hiroshi <musashino.open@gmail.com> Reviewed-by: Sungbo Eo <mans0n@gorani.run>
Diffstat (limited to 'target/linux/ramips/mt7621')
-rwxr-xr-xtarget/linux/ramips/mt7621/base-files/etc/board.d/02_network10
-rw-r--r--target/linux/ramips/mt7621/base-files/lib/upgrade/iodata.sh55
-rwxr-xr-xtarget/linux/ramips/mt7621/base-files/lib/upgrade/platform.sh4
3 files changed, 65 insertions, 4 deletions
diff --git a/target/linux/ramips/mt7621/base-files/etc/board.d/02_network b/target/linux/ramips/mt7621/base-files/etc/board.d/02_network
index 84fc283f4f..ffe5793a6e 100755
--- a/target/linux/ramips/mt7621/base-files/etc/board.d/02_network
+++ b/target/linux/ramips/mt7621/base-files/etc/board.d/02_network
@@ -72,6 +72,7 @@ ramips_setup_interfaces()
elecom,wrc-1900gst|\
elecom,wrc-2533gst|\
iodata,wn-ax1167gr|\
+ iodata,wn-dx1167r|\
iodata,wn-gx300gr|\
iodata,wnpr2600g|\
iptime,a8004t)
@@ -222,6 +223,11 @@ ramips_setup_macs()
xiaoyu,xy-c5)
wan_mac=$(macaddr_add "$(mtd_get_mac_binary factory 0x4)" 1)
;;
+ iodata,wn-dx1167r|\
+ xiaomi,mir3g-v2)
+ wan_mac=$(mtd_get_mac_binary factory 0xe006)
+ label_mac=$wan_mac
+ ;;
iodata,wnpr2600g)
wan_mac=$(mtd_get_mac_ascii u-boot-env wanaddr)
label_mac=$wan_mac
@@ -266,10 +272,6 @@ ramips_setup_macs()
lan_mac=$(mtd_get_mac_binary factory 0xe006)
label_mac=$lan_mac
;;
- xiaomi,mir3g-v2)
- wan_mac=$(mtd_get_mac_binary factory 0xe006)
- label_mac=$wan_mac
- ;;
zbtlink,zbt-we1326)
wan_mac=$(mtd_get_mac_binary factory 0xe006)
label_mac=$(mtd_get_mac_binary factory 0x4)
diff --git a/target/linux/ramips/mt7621/base-files/lib/upgrade/iodata.sh b/target/linux/ramips/mt7621/base-files/lib/upgrade/iodata.sh
new file mode 100644
index 0000000000..d7a3477f0a
--- /dev/null
+++ b/target/linux/ramips/mt7621/base-files/lib/upgrade/iodata.sh
@@ -0,0 +1,55 @@
+#
+# Copyright (C) 2019 OpenWrt.org
+#
+
+. /lib/functions.sh
+
+iodata_mstc_prepare_fail() {
+ echo "failed to check and prepare the environment, rebooting..."
+ umount -a
+ reboot -f
+}
+
+# I-O DATA devices manufactured by MSTC (MitraStar Technology Corp.)
+# have two important flags:
+# - bootnum: switch between two os images
+# use 1st image in OpenWrt
+# - debugflag: enable/disable debug
+# users can interrupt Z-Loader for recovering the device if enabled
+iodata_mstc_upgrade_prepare() {
+ local persist_mtd="$(find_mtd_part persist)"
+ local factory_mtd="$(find_mtd_part factory)"
+
+ if [ -z "$persist_mtd" -o -z "$factory_mtd" ]; then
+ echo 'cannot find mtd partition(s), "factory" or "persist"'
+ iodata_mstc_prepare_fail
+ fi
+
+ local bootnum=$(hexdump -s 4 -n 1 -e '"%x"' ${persist_mtd})
+ local debugflag=$(hexdump -s 65141 -n 1 -e '"%x"' ${factory_mtd})
+
+ if [ "$bootnum" != "1" -a "$bootnum" != "2" ]; then
+ echo "failed to get bootnum, please check the value at 0x4 in ${persist_mtd}"
+ iodata_mstc_prepare_fail
+ fi
+ if [ "$debugflag" != "0" -a "$debugflag" != "1" ]; then
+ echo "failed to get debugflag, please check the value at 0xFE75 in ${factory_mtd}"
+ iodata_mstc_prepare_fail
+ fi
+ echo "current: bootnum => ${bootnum}, debugflag => ${debugflag}"
+
+ if [ "$bootnum" = "2" ]; then
+ if ! (echo -ne "\x01" | dd bs=1 count=1 seek=4 conv=notrunc of=${persist_mtd} 2>/dev/null); then
+ echo "failed to set bootnum"
+ iodata_mstc_prepare_fail
+ fi
+ echo "### switch to 1st os-image on next boot ###"
+ fi
+ if [ "$debugflag" = "0" ]; then
+ if ! (echo -ne "\x01" | dd bs=1 count=1 seek=65141 conv=notrunc of=${factory_mtd} 2>/dev/null); then
+ echo "failed to set debugflag"
+ iodata_mstc_prepare_fail
+ fi
+ echo "### enable debug ###"
+ fi
+}
diff --git a/target/linux/ramips/mt7621/base-files/lib/upgrade/platform.sh b/target/linux/ramips/mt7621/base-files/lib/upgrade/platform.sh
index d74aba3bfe..e27f9df387 100755
--- a/target/linux/ramips/mt7621/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ramips/mt7621/base-files/lib/upgrade/platform.sh
@@ -53,6 +53,10 @@ platform_do_upgrade() {
xiaomi,mir3p)
nand_do_upgrade "$1"
;;
+ iodata,wn-dx1167r)
+ iodata_mstc_upgrade_prepare
+ nand_do_upgrade "$1"
+ ;;
ubiquiti,edgerouterx|\
ubiquiti,edgerouterx-sfp)
platform_upgrade_ubnt_erx "$1"